/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.benutzerverwaltung.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.benutzerverwaltung.entity.Benutzer;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractBenutzerSearch {

  @Inject
  protected transient BenutzerExtendedDAO dao;

  public AbstractBenutzerSearch() {
    super();
  }

  public List<Benutzer> getSearchResult(BenutzerSearchParameters searchParameters, EagerLoadingCollector<Benutzer> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<Benutzer> querySearchResult(BenutzerSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
